/*
RUNASPW gp@:

RUNASPW [ [/noprofile | /profile] [/env] [/netonly] [/wait]]
        /user:<[U[> /password:<pX[h> vO

   /noprofile        [U[̃vt@Cǂݍ܂Ȃ悤Ɏw肵܂B
                     ̌ʁAAvP[V葬ǂݍނƂł
                     Aꕔ̃AvP[V삵Ȃ\
                     ܂B
   /env              [U[̊ł͂ȂÅ݂gpꍇɎg܂
   /wait             NvȌI҂܂

   /user             <[U[> ̌`́A"[U[@hC" ܂
                     "hC\[U[" ł
   /password         pX[hw肵܂
   vO        s\ȃR}hCłB̗QƂĂB

:
> runaspw /noprofile /user:mymachine\administrator cmd
> runaspw /env /user:user@domain.microsoft.com "notepad \"my file.txt\""


Copyright (c)2007  Kazuyoshi Kakihara

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
#define _WIN32_WINNT 0x0500
#include <windows.h>

BOOL fstricmplim1(PCSTR str1, PCSTR str2)
{
  int len = lstrlen(str1);
  if (CompareString(LOCALE_USER_DEFAULT, NORM_IGNORECASE, str1, len, str2, len) == CSTR_EQUAL) {
    return TRUE;
  }
  return FALSE;
}

LPWSTR ToWideString(PCSTR str, int len)
{
  int lenw = 0;
  LPWSTR wstr = NULL;

  lenw = MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS, str, len, NULL, 0);
  if (lenw == 0) {
    return NULL;
  }
  wstr = HeapAlloc(GetProcessHeap(), 0, (lenw + 1) * sizeof(WCHAR));
  if (!wstr) {
    return NULL;
  }
  lenw = MultiByteToWideChar(CP_ACP, MB_ERR_INVALID_CHARS, str, len, wstr, lenw + 1);
  if (lenw == 0) {
    HeapFree(GetProcessHeap(), 0, wstr);
    return NULL;
  }
  *(wstr + lenw) = L'\0';
  return wstr;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
  BOOL fNoProfile = FALSE;
  BOOL fWait = FALSE;
  LPWSTR pUserBase = NULL;
  LPWSTR pUser = NULL;
  LPWSTR pDomain = NULL;
  LPWSTR pPassword = NULL;
  LPWSTR pCommand = NULL;
  LPVOID pEnv = NULL;
  int iRet = 0;

  STARTUPINFOW si;
  PROCESS_INFORMATION pi;

  PCSTR p = lpCmdLine;

  /* 󔒕ǂݔ΂ */
  while (*p == ' ') ++p;

  /* R}hC */
  while (*p) {
    if (*p != '/') break;
    if (fstricmplim1("/noprofile ", p)) {
      fNoProfile = TRUE;
      p += lstrlen("/noprofile ");
    } else if (fstricmplim1("/env ", p)) {
      pEnv = GetEnvironmentStrings();
      p += lstrlen("/env ");
    } else if (fstricmplim1("/wait ", p)) {
      fWait = TRUE;
      p += lstrlen("/wait ");
    } else if (fstricmplim1("/user:", p)) {
      PCSTR p0;
      BOOL fDq = FALSE;
      PWSTR pw;

      p += lstrlen("/user:");
      p0 = p;
      if ((!*p) || (*p == ' ')) {
        MessageBox(NULL, "Invalid Command Line Args.", "RunAsEX Error", MB_OK);
        iRet = -1;
        goto finish_func;
      }
      while ((*p != ' ') && (fDq == FALSE)) {
        if (*p == '"') fDq = !fDq;
        ++p;
        if (!*p) {
          MessageBox(NULL, "Invalid Command Line Args.", "RunAsEX Error", MB_OK);
          iRet = -1;
          goto finish_func;
        }
      }
      pUserBase = ToWideString(p0, p - p0);
      if (!pUserBase) {
        MessageBox(NULL, "Invalid User.", "RunAsEX Error", MB_OK);
        iRet = GetLastError();
        goto finish_func;
      }
      pw = pUserBase;
      pUser = pUserBase;
      while (*pw != L'\0') {
        if (*pw == L'\\') {
          *pw = L'\0';
          pDomain = pUserBase;
          pUser = pw + 1;
          break;
        } else if (*pw == L'@') {
          *pw = L'\0';
          pDomain = pw + 1;
          pUser = pUserBase;
          break;
        }
        ++pw;
      }
    } else if (fstricmplim1("/password:", p)) {
      PCSTR p0;

      p += lstrlen("/password:");
      p0 = p;
      if (!*p) {
        MessageBox(NULL, "Invalid Passowrd.", "RunAsEX Error", MB_OK);
        iRet = GetLastError();
        goto finish_func;
      }
      while (*p != ' ') {
        ++p;
        if (!*p) {
          MessageBox(NULL, "Invalid Command Line Args.", "RunAsEX Error", MB_OK);
          iRet = GetLastError();
          goto finish_func;
        }
      }
      if (p == p0) {
        MessageBox(NULL, "Invalid Passowrd.", "RunAsEX Error", MB_OK);
        iRet = GetLastError();
        goto finish_func;
      }
      pPassword = ToWideString(p0, p - p0);
      if (!pPassword) {
        MessageBox(NULL, "Invalid Passowrd.", "RunAsEX Error", MB_OK);
        iRet = GetLastError();
        goto finish_func;
      }
    } else {
      MessageBox(NULL, "Invalid Command Line Args.", "RunAsEX Error", MB_OK);
      iRet = -1;
      goto finish_func;
    }
    /* 󔒕ǂݔ΂ */
    while (*p == ' ') ++p;
  }

  pCommand = ToWideString(p, -1);
  if (!pCommand) {
    MessageBox(NULL, "Invalid Comand Line Args.", "RunAsEX Error", MB_OK);
    iRet = GetLastError();
    goto finish_func;
  }
  ZeroMemory(&si, sizeof(STARTUPINFO));
  si.cb = sizeof(STARTUPINFO);

  if (CreateProcessWithLogonW(pUser, pDomain, pPassword, fNoProfile ? 0 : LOGON_WITH_PROFILE,
    NULL, pCommand, 0, pEnv, NULL, &si, &pi) == 0) {
    iRet = GetLastError();
    goto finish_func;
  }
  CloseHandle(pi.hThread);
  if (fWait) {
    WaitForSingleObject(pi.hProcess, INFINITE);
  }
  CloseHandle(pi.hProcess);
finish_func:
  if (pUserBase) HeapFree(GetProcessHeap(), 0, pUserBase);
  if (pPassword) HeapFree(GetProcessHeap(), 0, pPassword);
  if (pCommand) HeapFree(GetProcessHeap(), 0, pCommand);
  if (pEnv) FreeEnvironmentStrings(pEnv);
  return iRet;
}

